# Rust Lambda Function with Logging and Tracing

This project implements logging and tracing functionalities in a Rust Lambda function (same function implemented in week 2) and integrates them with AWS X-Ray for distributed tracing. Additionally, it connects logs and traces to CloudWatch for centralized monitoring and analysis.

## Functionality Overview

The Lambda function performs the following steps:

1. Receives weight and height as query parameters.
2. Calculates BMI using the provided weight and height.
3. Determines the BMI category based on the calculated BMI value.
4. Constructs a JSON response containing the BMI value and category.
5. Sends the response back to the client.

## Code Overview

The main components of the Rust code are as follows:

- `BMIResponse`: A struct representing the BMI response containing the BMI value and category.
- `bmi_handler`: An asynchronous function that handles the BMI calculation and response construction.
- `main`: The entry point of the application, setting up logging, initializing the service, and running the Lambda function.

## Logging and Tracing

Logging and tracing are implemented using the `tracing` and `tracing-subscriber` crates. The logging level is set to INFO, and logs are printed to the standard output. Tracing information can be integrated with AWS X-Ray for distributed tracing.

## Implementation Details

- **Logging**: Implemented using the `tracing` and `tracing-subscriber` crates. Logs are printed to the standard output.
- **X-Ray Tracing**: Integrated using the `rusoto_xray` crate. X-Ray segments and subsegments are used to trace requests.
- **CloudWatch Centralization**: Logs generated by the Lambda function are sent to CloudWatch Logs for centralized storage and analysis.


## Instructions

1. Build the Rust code and package it as a ZIP file.
2. Create a Lambda function in the AWS Management Console or using AWS CLI.
3. Upload the ZIP file containing the Rust code to the Lambda function.
4. Configure the Lambda function to use an appropriate execution role and set the runtime to Rust.
5. Set up environment variables or modify the code to accept input parameters.
6. Test the Lambda function with sample input data and verify the output.
7. Monitor logs and traces in CloudWatch and X-Ray consoles for debugging and performance analysis.

## API Endpoint

The Lambda function is accessible via the following API endpoint:

- **Endpoint**: [https://7aiuz6gmsi.execute-api.us-east-1.amazonaws.com/prod/test-res](https://7aiuz6gmsi.execute-api.us-east-1.amazonaws.com/prod/test-res)

### Usage

To use the Lambda function, send a POST request to the provided endpoint with the required query parameters:

- `weight`: The weight in kilograms (kg).
- `height`: The height in meters (m).

### Example Request

```http
POST https://7aiuz6gmsi.execute-api.us-east-1.amazonaws.com/prod/test-res?weight=70&height=1.75
```

## Dependencies

The project uses the following dependencies:

- `lambda_http`: For handling HTTP requests and responses in the Lambda function.
- `lambda_runtime`: For running the Lambda function.
- `serde_json`: For serializing and deserializing JSON data.
- `tracing` and `tracing-subscriber`: For logging and tracing functionality.

## Screenshots
![](img/a.png)
![](img/b.png)
![](img/c.png)
![](img/d.png)
![](img/e.png)

## Contributing

Contributions to this project are welcome. If you find any issues or have suggestions for improvement, please create a pull request or submit an issue on GitHub.

